<script>
import CardBasicStyle from '~/components/common/card-basic-style.vue';
import DemoModal from '~/components/common/demo-modal.vue';

export default {
  name: 'DemoCtaCard',
  components: { CardBasicStyle, DemoModal },
  props: {
    data: { type: Object, required: true },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    openModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
};
</script>

<template>
  <section class="cta-card">
    <CardBasicStyle id="demo" no-hover>
      <div class="video-text">
        <SlpTypography
          class="slp-mb-24 video-text__title"
          tag="h2"
          variant="heading2-bold"
        >
          {{ data?.title }}
        </SlpTypography>
        <SlpTypography
          class="video-text__description"
          tag="div"
          variant="body1"
        >
          {{ data?.description }}
        </SlpTypography>
      </div>
      <div class="video">
        <div
          class="image__container"
          :data-ga-location="data.launchButton.data_ga_location"
          :data-ga-name="data.launchButton.data_ga_name"
          @click="openModal"
        >
          <img
            class="demo-thumbnail"
            :src="data.demo.video.thumbnail"
            :alt="data.demo.video.altText"
          />
          <SlpButton variant="secondary" class="slp-mt-32 demo-button">
            <SlpIcon
              :name="data.launchButton.icon_name"
              :variant="data.launchButton.icon_variant"
              alt="laptop-play-video"
            />{{ data.launchButton.text }}</SlpButton
          >
        </div>
      </div>

      <DemoModal
        v-show="modal.open"
        :data="data.demo"
        :visible="modal.open"
        @close="closeModal"
      >
      </DemoModal>
    </CardBasicStyle>
  </section>
</template>

<style lang="scss" scoped>
.cta-card {
  margin: 96px 0 96px 0;
}
#demo {
  padding: 48px;
  margin-bottom: 96px;
  display: flex;
  flex-direction: row;
  align-items: center;
  .video-text {
    display: flex;
    flex-direction: column;
    justify-content: center;
    flex: 2 1 0;
    padding-left: $spacing-8;
    &__description {
      margin-bottom: 32px;
    }
  }
  .video {
    max-width: 460px;
    height: fit-content;
    display: flex;
    flex: 2 1 0;
    .image__container {
      display: flex;
      position: relative;
      border-radius: 4px;
      border: 0.5px solid black;
      overflow: hidden;
      &::before {
        content: '';
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background: linear-gradient(
          to bottom,
          rgba(110, 73, 203, 0.3) rgba(255, 212, 216, 0.45)
        );
        opacity: 0;
        transition: opacity 0.3s ease-in-out;
      }
      &:hover::before {
        opacity: 1;
      }
    }
    .demo-thumbnail {
      max-width: 100%;
      display: block;
      height: auto;
      filter: blur(1px);
      z-index: 1;
      transition: filter 0.3s ease-in-out;
      &:hover {
        z-index: 0;
        cursor: pointer;
        background: linear-gradient(
          to bottom,
          rgba(110, 73, 203, 0.3) rgba(255, 212, 216, 0.45)
        );
      }
    }
  }
  .demo-button {
    position: absolute;
    top: 37%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: 2;
    border-radius: 30px;
    &:hover {
      box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);
    }
    .slp-icon {
      margin-right: 5px;
      width: 24px;
      height: 24px;
    }
  }
  @media (max-width: $breakpoint-sm) {
    display: flex;
    flex-direction: column;
    padding: $spacing-32;

    .image__container {
      max-width: 100%;
    }
    .video-text {
      padding: 0 0 0 0;
    }

    .video {
      width: fit-content;
      display: flex;
      flex-wrap: wrap;
      align-items: center;
    }

    .demo-button {
      position: absolute;
      top: 30%;
      left: 50%;
      font-size: 16px;
      width: 170px;
      transform: translate(-50%, -50%);
    }
  }
}
</style>
